unit ats;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Spin, ComCtrls,
  CheckLst, Buttons, mmSystem, pngextra, Menus, ActnList;

type
  Tat_addedit_form = class(TForm)
    alarm_panel: TPanel;
    Label2: TLabel;
    Label4: TLabel;
    wav_file_input: TComboBox;
    Label9: TLabel;
    Bevel1: TBevel;
    Label20: TLabel;
    a_del_button: TCheckBox;
    a_active_button: TCheckBox;
    active_button: TCheckBox;
    ok_button: TButton;
    cancel_button: TButton;
    rings_unlimit_button: TCheckBox;
    ring_nums_edit: TSpinEdit;
    Bevel4: TBevel;
    timeEdit: TDateTimePicker;
    dateEdit: TDateTimePicker;
    Label1: TLabel;
    timer_panel: TPanel;
    a_mode: TRadioGroup;
    a_days: TCheckListBox;
    Label3: TLabel;
    note_input: TEdit;
    Bevel3: TBevel;
    browse_button: TButton;
    play_button: TPNGButton;
    use_wav_button: TRadioButton;
    say_time_button: TRadioButton;
    popUp_button: TCheckBox;
    onAppRun: TCheckBox;
    onesInDay: TCheckBox;
    useSpace: TCheckBox;
    Label10: TLabel;
    Label11: TLabel;
    activeFrom: TSpinEdit;
    activeTo: TSpinEdit;
    Label13: TLabel;
    groupSelect: TComboBox;
    add_group_button: TPNGButton;
    reset_onesInDay_button: TPNGButton;
    daysMenu: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    use_sound_button: TCheckBox;
    Label5: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label12: TLabel;
    t_del_button: TCheckBox;
    t_reset_button: TCheckBox;
    t_active_button: TCheckBox;
    t_changeSynch_button: TCheckBox;
    t_mc_input: TSpinEdit;
    Label16: TLabel;
    t_sc_input: TSpinEdit;
    t_ss_input: TSpinEdit;
    Label8: TLabel;
    t_ms_input: TSpinEdit;
    Label7: TLabel;
    t_hs_input: TSpinEdit;
    t_hc_input: TSpinEdit;
    Label14: TLabel;
    Label15: TLabel;
    Label19: TLabel;
    Bevel2: TBevel;
    t_profile_button: TLabel;
    profilesMenu: TPopupMenu;
    ActionList1: TActionList;
    _cancel: TAction;
    _ok: TAction;
    procedure _okExecute(Sender: TObject);
    procedure _cancelExecute(Sender: TObject);
    procedure t_profile_buttonClick(Sender: TObject);
    procedure t_changeSynch_buttonClick(Sender: TObject);
    procedure t_hc_inputChange(Sender: TObject);
    procedure t_hs_inputChange(Sender: TObject);
    procedure use_sound_buttonClick(Sender: TObject);
    procedure N10Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure reset_onesInDay_buttonClick(Sender: TObject);
    procedure onesInDayClick(Sender: TObject);
    procedure add_group_buttonClick(Sender: TObject);
    procedure useSpaceClick(Sender: TObject);
    procedure onAppRunClick(Sender: TObject);
    procedure rings_unlimit_buttonClick(Sender: TObject);
    procedure say_time_buttonClick(Sender: TObject);
    procedure use_wav_buttonClick(Sender: TObject);
    procedure use_not_sound_buttonClick(Sender: TObject);
    procedure play_buttonClick(Sender: TObject);
    procedure a_modeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure t_active_buttonClick(Sender: TObject);
    procedure t_reset_buttonClick(Sender: TObject);
    procedure t_del_buttonClick(Sender: TObject);
    procedure a_active_buttonClick(Sender: TObject);
    procedure a_del_buttonClick(Sender: TObject);
    procedure browse_buttonClick(Sender: TObject);
    procedure cancel_buttonClick(Sender: TObject);
    procedure is12_buttonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    editing: boolean;
  published
    procedure wavCompEnabled(const value: boolean = true);
    procedure buildTimerProfeilesList;

    procedure addNewProfile(sender: tObject);
    procedure delProfile(const index: smallInt);

    procedure profileItemClick(sender: tObject);

    procedure setAddItem;
  end;

var
  at_addedit_form: Tat_addedit_form;

implementation

uses global_vars, utils, groupEdit, dateUtils, timer_utils;

{$R *.dfm}

procedure{  }Tat_addedit_form.cancel_buttonClick(Sender: TObject);
begin
   if tButton(sender).Tag = 1 then isOk := true;
   close;
end;

procedure Tat_addedit_form._cancelExecute(Sender: TObject);
begin
   cancel_button.OnClick(cancel_button);
end;

procedure Tat_addedit_form._okExecute(Sender: TObject);
begin
   ok_button.OnClick(ok_button);
end;

procedure Tat_addedit_form.delProfile(const index: smallInt);
var
c, h: smallInt;
begin
   h := high(timerProfiles);

   if (h < 0) or (Index < 0) then exit;

   if Index > h then
   begin
      buildTimerProfeilesList;
      exit;
   end;   

   for c := Index to h - 1 do
   timerProfiles[c] := timerProfiles[c + 1];

   setLength(timerProfiles, h);

   buildTimerProfeilesList;
end;

procedure{   Wav- }Tat_addedit_form.FormCreate(Sender: TObject);
var
sr: tSearchRec;
path: string;
begin
   wav_file_input.Items.Clear;
   path := extractFilePath(application.ExeName);
   if findFirst(path+'_work\Sounds\*.wav', faAnyFile, sr) = 0 then
   begin
      wav_file_input.Items.Add(path+'_work\Sounds\'+sr.Name);
      while findNext(sr) = 0 do wav_file_input.Items.Add(path+'_work\Sounds\'+sr.Name);
   end;
   findClose(sr);
   if wav_file_input.Items.Count > 0 then
     wav_file_input.Text := wav_file_input.Items.Strings[0]
     else wav_file_input.Text := '';
end;

procedure Tat_addedit_form.addNewProfile(sender: tObject);
var
ts: string;
h: smallInt;
begin
   repeat
      if not inputQuery('   ',
      '    ', ts) then exit;
   until trim(ts) <> '';

   h := high(timerProfiles);
   setLength(timerProfiles, h + 2);
   inc(h);
   timerProfiles[h].name := ts;
   timer.assignValues(timerProfiles[h].rec, false);
   buildTimerProfeilesList;
end;

procedure{   }Tat_addedit_form.add_group_buttonClick(Sender: TObject);
var
h: smallInt;
begin
   h := high(groups);
   groupEdit_form.add_button.OnClick(nil);
   if h < high(groups) then
   groupSelect.ItemIndex := high(groups);
end;

procedure{    }Tat_addedit_form.a_active_buttonClick(Sender: TObject);
begin
   if a_active_button.checked then a_del_button.checked := false;
end;

procedure{    }Tat_addedit_form.a_del_buttonClick(Sender: TObject);
begin
   if a_del_button.checked then a_active_button.checked := false;
end;

procedure{   }Tat_addedit_form.a_modeClick(Sender: TObject);
begin
   a_days.Enabled := a_mode.ItemIndex = 1;
   label3.Enabled := a_mode.ItemIndex = 1;
   dateEdit.Enabled := (a_mode.ItemIndex <> 1);
end;

procedure{  .   }Tat_addedit_form.browse_buttonClick(Sender: TObject);
var
open_dialog: tOpenDialog;
begin
   open_dialog := tOpenDialog.Create(self);
   open_dialog.filter := 'Wav  (*.Wav)|*.wav|  |*.*';
   if open_dialog.Execute then wav_File_input.Text := open_dialog.FileName;
   open_dialog.Free;
end;

procedure Tat_addedit_form.buildTimerProfeilesList;
var
c, h: smallInt;
begin
   profilesMenu.Items.Clear;

   h := high(timerProfiles);
   if h < 0 then
   begin
      setAddItem;
      exit;
   end;

   for c := 0 to h do
   begin
      profilesMenu.Items.Add(tMenuItem.Create(profilesMenu));
      profilesMenu.Items[c].Caption := timerProfiles[h - c].name;
      profilesMenu.Items[c].OnClick := profileItemClick;
      profilesMenu.Items[c].Tag := h - c;
   end;

   setAddItem;
end;

procedure{ 12/24   }Tat_addedit_form.is12_buttonClick(Sender: TObject);
begin
   {isPm_button.enabled := is12_button.checked;

   if not utils_form.s3_btn.checked then exit;
   if is12_button.checked then
   begin
     if a_h_input.Value > 12 then
       a_h_input.Value := a_h_input.Value - 12;
   end
   else
   begin
      if isPm_button.Checked then
        if a_h_input.Value < 12 then
          a_h_input.Value := a_h_input.Value + 12;
        if a_h_input.Value = 12 then
          a_h_input.Value := 0;
   end;}
end;

procedure Tat_addedit_form.N10Click(Sender: TObject);
var
c: smallInt;
begin
   for c := 0 to 6 do
      a_days.Checked[c] := tMenuItem(sender).Tag = c;
end;

procedure Tat_addedit_form.N1Click(Sender: TObject);
var
c: smallInt;
begin
   for c := 0 to 6 do
      a_days.Checked[c] := true;
end;

procedure Tat_addedit_form.N2Click(Sender: TObject);
var
c: smallInt;
begin
   for c := 0 to 6 do
      a_days.Checked[c] := false;
end;

procedure Tat_addedit_form.onAppRunClick(Sender: TObject);
begin
   timeEdit.Enabled := not onAppRun.Checked;
   onesInDay.Enabled := onAppRun.Checked;
   useSpace.Enabled := onAppRun.Checked;
   label10.Enabled := useSpace.Checked and onAppRun.Checked;
   label11.Enabled := useSpace.Checked and onAppRun.Checked;
   activeFrom.Enabled := useSpace.Checked and onAppRun.Checked;
   activeTo.Enabled := useSpace.Checked and onAppRun.Checked;
   onesInDay.OnClick(nil);
end;

procedure Tat_addedit_form.onesInDayClick(Sender: TObject);
begin
   if editing then
      reset_onesInDay_button.Enabled := onesInDay.Checked and onesInDay.Enabled and
      (dateOf(alarms[al_first_selected].rang_in) = date) and
      (dateOf(alarms[al_first_selected].set_on) = date);
end;
procedure{    }Tat_addedit_form.play_buttonClick(Sender: TObject);
begin
   sndPlaySound(pChar(wav_file_input.Text), SND_ASYNC); 
end;

procedure Tat_addedit_form.profileItemClick(sender: tObject);
begin
   if ctrlPress then
   begin
      if messageDlg('     "'+
      timerProfiles[tMenuItem(sender).tag].name+'"?',
      mtConfirmation, mbYesNo, 0) <> mrYes then exit;

      delProfile(tMenuItem(sender).tag);
      exit;
   end;

   if high(timerProfiles) < 0 then
   begin
      buildTimerProfeilesList;
      exit;
   end;

   {if messageDlg('     "'+
   timerProfiles[tMenuItem(sender).tag].name+'"?',
      mtConfirmation, mbYesNo, 0) = mrYes then
   begin}
   t_changeSynch_button.checked := false;
      timer.setValues(timerProfiles[tMenuItem(sender).tag].rec);
   //end;

   buildTimerProfeilesList;
end;

procedure Tat_addedit_form.reset_onesInDay_buttonClick(Sender: TObject);
begin
   reset_onesInDay_button.Enabled := false;
   alarms[al_first_selected].rang_in := 0;
end;

procedure Tat_addedit_form.rings_unlimit_buttonClick(Sender: TObject);
begin
   ring_nums_edit.Enabled := not rings_unlimit_button.Checked;
end;

procedure Tat_addedit_form.say_time_buttonClick(Sender: TObject);
begin
   wavCompEnabled(false);
end;

procedure Tat_addedit_form.setAddItem;
var
h: smallInt;
begin
   h := profilesMenu.Items.Count - 1;
   if h >= 0 then
   begin
      profilesMenu.Items.Add(tMenuItem.Create(profilesMenu));
      profilesMenu.Items[h+1].Caption := '-';
   end;
   h := profilesMenu.Items.Count - 1;
   profilesMenu.Items.Add(tMenuItem.Create(profilesMenu));
   profilesMenu.Items[h+1].Caption := '( . )';
   profilesMenu.Items[h+1].OnClick := addNewProfile;
end;

procedure{        }Tat_addedit_form.t_active_buttonClick(Sender: TObject);
begin
   if t_active_button.checked then
   begin
      t_reset_button.checked := true;
      t_del_button.checked := false;
   end;
end;

procedure Tat_addedit_form.t_changeSynch_buttonClick(Sender: TObject);
begin
   if t_changeSynch_button.Checked then
      t_hs_inputChange(nil);
end;

procedure{    }Tat_addedit_form.t_del_buttonClick(Sender: TObject);
begin
   t_reset_button.checked := not t_del_button.checked;
   if t_del_button.checked then t_active_button.checked := false;
end;

procedure Tat_addedit_form.t_hc_inputChange(Sender: TObject);
begin
   if not t_changeSynch_button.Checked then exit;
   
   t_hs_input.Value := t_hc_input.Value;
   t_ms_input.Value := t_mc_input.Value;
   t_ss_input.Value := t_sc_input.Value;
end;

procedure Tat_addedit_form.t_hs_inputChange(Sender: TObject);
begin
   if not t_changeSynch_button.Checked then exit;

   t_hc_input.Value := t_hs_input.Value;
   t_mc_input.Value := t_ms_input.Value;
   t_sc_input.Value := t_ss_input.Value;
end;

procedure Tat_addedit_form.t_profile_buttonClick(Sender: TObject);
var
p: tPoint;
begin
   if not ctrlPress then
   begin
      getCursorPos(p);
      profilesMenu.Popup(p.x, p.y);
      exit;
   end;
   if messageDlg('     ?',
      mtConfirmation, mbYesNo, 0) = mrYes then
   begin
      setLength(timerProfiles, 0);
      buildTimerProfeilesList;
   end;
end;

procedure{      }Tat_addedit_form.t_reset_buttonClick(Sender: TObject);
begin
   if not t_reset_button.checked then t_active_button.checked := false;
   t_del_button.checked := not t_reset_button.checked;
end;

procedure Tat_addedit_form.useSpaceClick(Sender: TObject);
begin
   label10.Enabled := useSpace.Checked;
   label11.Enabled := useSpace.Checked;
   activeFrom.Enabled := useSpace.Checked;
   activeTo.Enabled := useSpace.Checked;
end;

procedure Tat_addedit_form.use_not_sound_buttonClick(Sender: TObject);
begin
   wavCompEnabled(false);
end;

procedure Tat_addedit_form.use_sound_buttonClick(Sender: TObject);
begin
   use_wav_button.Enabled := use_sound_button.Checked;
   say_time_button.Enabled := use_sound_button.Checked and (@sayTime <> nil);

   if (not use_wav_button.Checked) and (not say_time_button.Checked) then
      use_wav_button.Checked := true;

   wavCompEnabled(use_sound_button.Checked and use_wav_button.Checked);
end;

procedure Tat_addedit_form.use_wav_buttonClick(Sender: TObject);
begin
   wavCompEnabled;
end;

procedure{ / wav }Tat_addedit_form.wavCompEnabled(const value: boolean);
begin
   wav_file_input.Enabled := value;
   browse_button.Enabled := value;
   play_button.Enabled := value;
   label2.Enabled := value;
   rings_unlimit_button.Enabled := value;
   //ring_nums_edit.Enabled := value;
   rings_unlimit_buttonClick(nil);
   if not value then ring_nums_edit.Enabled := false;
   
end;

end.
