unit calendarEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, dateUtils, StdCtrls, Spin, Grids, Calendar,
  atomikCalendar, Menus, CheckLst, Buttons, pngextra;

type
  TcalendarEdit_form = class(TForm)
    dayEdit: tAtomikCalendar;
    yearEdit: TSpinEdit;
    MonthEdit: TComboBox;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    more_btn: TSpeedButton;
    calendar_mode: TCheckListBox;
    previous_btn: TPNGButton;
    next_btn: TPNGButton;
    N2: TMenuItem;
    N3: TMenuItem;
    procedure N3Click(Sender: TObject);
    procedure MonthEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure previous_btnClick(Sender: TObject);
    procedure next_btnClick(Sender: TObject);
    procedure calendar_modeClick(Sender: TObject);
    procedure more_btnClick(Sender: TObject);
    procedure dayEditAfterCellDrow(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure showDaylyAlarms_btnClick(Sender: TObject);
    procedure dayEditBeforCellDrow(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
      State: TGridDrawState);
    procedure MonthEditChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure dayEditClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  calendarEdit_form: TcalendarEdit_form;

implementation

uses utils, alarm_utils, global_vars;

{$R *.dfm}

{ Tcalendar_form }

procedure TcalendarEdit_form.calendar_modeClick(Sender: TObject);
begin
   calendarRepaint;
end;

procedure TcalendarEdit_form.dayEditAfterCellDrow(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
begin
   if gdSelected in State then
   begin
      dayEdit.canvas.Brush.Style := bsClear;
      dayEdit.canvas.Pen.Color := clWindowText;
      dayEdit.canvas.Rectangle(rect.Left,  rect.Top, rect.Right,
      rect.Bottom);
   end;

   if (aRow = 0) or (dayEdit.CellText[aCol, aRow] = '') then exit;

   if encodeDate(yearEdit.Value, monthEdit.ItemIndex+1,
     strToInt(dayEdit.CellText[aCol, aRow])) = today then
   begin
      dayEdit.canvas.Brush.Style := bsClear;
      dayEdit.canvas.Pen.Color := clRed;
      dayEdit.canvas.Rectangle(rect.Left+1,  rect.Top+1, rect.Right-1,
      rect.Bottom-1);
   end;
end;

procedure TcalendarEdit_form.dayEditBeforCellDrow(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
fonColor: tColor;
fontStyle: tFontStyles;
fontColor: tColor;
counter: smallInt;
day: smallInt;
procedure testDate(const value: tDate);
var
counter: smallInt;
begin
   if high(alarms) < 0 then exit;
   for counter := 0 to high(alarms) do
   begin
      if not alarms[counter].active and calendar_mode.Checked[4] then continue;

      if (alarms[counter].groupIndex >= 0) and (high(groups) >= 0) then
         if not groups[alarms[counter].groupIndex].visible and
         calendar_mode.Checked[5] then continue;

      case alarms[counter].mode of
      0: if (dateOf(alarms[counter].set_on) = value) and calendar_mode.Checked[0] then
         begin
            fonColor := $00ECECFF;
            //fontColor := clHotLight;
         end;
      {1: if alarms[counter].days[dayOfWeek(value)] then
         begin
            //fontStyle := fontStyle + [fsBold];
            //fontColor := clWindowText;
         end;}
      2: if (dayOf(alarms[counter].set_on) = dayOf(value)) and calendar_mode.Checked[2] then
         begin
            fonColor := $00ECECFF;
            //fontColor := clHotLight;
         end;
      3: if (dayOf(alarms[counter].set_on) = dayOf(value)) and
         (monthOf(alarms[counter].set_on) = monthOf(value)) and calendar_mode.Checked[3] then
         begin
            fonColor := $00ECECFF;
            fontColor := clRed;
         end;
      end;
   end;
end;
begin
   if dayEdit.CellText[aCol, aRow] = '' then exit;
   if aRow = 0 then
   begin
      if high(alarms) < 0 then exit;
      for counter := 0 to high(alarms) do
      begin
         if not alarms[counter].active and calendar_mode.Checked[4] then continue;

         if (alarms[counter].groupIndex >= 0) and (high(groups) >= 0) then
           if not groups[alarms[counter].groupIndex].visible and
           calendar_mode.Checked[5] then continue;

         if (alarms[counter].mode = 1) and calendar_mode.Checked[1] then
         begin
            day := aCol + 2;
            if day > 7 then day := 1;
            if alarms[counter].days[day] then
            begin
               dayEdit.canvas.Font.Style := dayEdit.canvas.Font.Style + [fsBold];
               dayEdit.canvas.Font.Color := clHotLight;
            end;
         end;
      end;
      exit;
   end;

   fonColor := clWindow;
   fontStyle := [];
   fontColor := clWindowText;

   testDate(encodeDate(yearEdit.Value, monthEdit.ItemIndex+1, strToInt(dayEdit.CellText[aCol, aRow])));

   dayEdit.canvas.Brush.Color := fonColor;
   dayEdit.canvas.Font.Style := fontStyle;
   dayEdit.canvas.Font.Color := fontColor;

   if gdSelected in State then
      dayEdit.canvas.Font.Style := dayEdit.canvas.Font.Style + [fsUnderline];
end;

procedure TcalendarEdit_form.dayEditClick(Sender: TObject);
begin
   alarm.selectDate(dayEdit.CalendarDate);
end;

procedure TcalendarEdit_form.MonthEditChange(Sender: TObject);
var
dayCount: byte;
begin
   dayCount := DaysInMonth(EncodeDateTime(
   yearEdit.Value, monthEdit.ItemIndex + 1, 1, 0, 0, 0, 0));
   if dayEdit.Day > dayCount then dayEdit.Day := dayCount;
   dayEdit.Month := monthEdit.ItemIndex + 1;
   dayEdit.Year := yearEdit.Value;

   caption := ': '+dateToStr(dayEdit.CalendarDate);
end;

procedure TcalendarEdit_form.MonthEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   case key of
   {27: begin close; utils_form.alarm_list.SetFocus; end;
   13: dayEditClick(nil);}

   38: if ctrlPress then yearEdit.Value := yearEdit.Value + 1;
   40: if ctrlPress then yearEdit.Value := yearEdit.Value - 1;
   37: if ctrlPress then previous_btn.OnClick(nil);
   39: if ctrlPress then next_btn.OnClick(nil);
   end;
end;

procedure TcalendarEdit_form.more_btnClick(Sender: TObject);
begin
   if more_btn.Down then
      ClientHeight := 294
   else
      ClientHeight := 206;
end;

procedure TcalendarEdit_form.N3Click(Sender: TObject);
begin
   alarm.add(dayEdit.CalendarDate);
end;

procedure TcalendarEdit_form.next_btnClick(Sender: TObject);
begin
   if monthEdit.ItemIndex < monthEdit.Items.Count - 1 then
      monthEdit.ItemIndex := monthEdit.ItemIndex + 1
   else
   begin
      monthEdit.ItemIndex := 0;
      yearEdit.Value := yearEdit.Value + 1;
   end;
   MonthEditChange(nil);
end;

procedure TcalendarEdit_form.previous_btnClick(Sender: TObject);
begin
   if monthEdit.ItemIndex > 0 then
      monthEdit.ItemIndex := monthEdit.ItemIndex - 1
   else 
   begin
      monthEdit.ItemIndex := monthEdit.Items.Count - 1;
      yearEdit.Value := yearEdit.Value - 1;
   end;

   MonthEditChange(nil);
end;

procedure TcalendarEdit_form.showDaylyAlarms_btnClick(Sender: TObject);
begin
   dayEdit.Repaint;
end;

procedure TcalendarEdit_form.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   //utils_form.showCalendar_button.Down := false;
end;

procedure TcalendarEdit_form.FormShow(Sender: TObject);
begin
   {   
   - ,     }
   dayEdit.CalendarDate := today;
   yearEdit.Value := dayEdit.Year;
   monthEdit.ItemIndex := dayEdit.Month - 1;
   dayEdit.CalendarDate := today;
   yearEdit.Value := dayEdit.Year;
   monthEdit.ItemIndex := dayEdit.Month - 1;
   caption := ' - '+dateToStr(dayEdit.CalendarDate);
   calendarRepaint;
end;

end.
