unit global_vars;

interface

uses ats, secMer_utils, utils, TimeDateLabel,
  Classes, ExtCtrls;


type
   group_rec = record
   name: string;
   alarmsCount: smallInt;
   selected, visible: boolean;
   end;

   alarms_rec = record
   set_on, rang_in: tDateTime;
   activeFrom, activeTo: smallInt;
   groupIndex, itemIndex: smallInt;
   note, music_way: string;
   active, use_wav, say_time, onAppRun, onesInDay, useSpace,
   rings_unlimit, del_alarm, set_unactive, editing, selected, showPopUp: boolean;
   mode, rings_num: byte; days: array [1..7] of boolean;
   end;

   timers_rec = record
   set_in: tDateTime;
   note: string;
   music_way: string; active,
   use_wav, say_time, time_out, rings_unlimit,
   del_timer, reset_timer, set_unactive, editing, selected, showPopUp: boolean;
   ct_h, ct_m, ct_s, so_h, so_m, so_s, rings_num: byte;
   end;

   secMers_rec = record
   set_in: tDateTime;
   note: string;
   l_sec, l_min, l_hour: byte;
   active, editing, selected: boolean;
   end;
var
AllowPlaying: function(const playnigStarted: boolean = false): boolean; stdCall;
setRinging: procedure(const ring: boolean); stdCall;
sayTime: procedure(const hour, minute: word; const handle: tHandle; const user: integer); stdCall;
stopSpeaking: procedure;

noteHistory: string = '';
days: array [1..7] of string = ('', '',
  '', '', '', '', '');

months: array [1..12] of string = ('', '', '',
  '', '', '', '', '', '',
  '', '', '');

procedure calendarRepaint;
function checkSymbols(const value: string): boolean;
function timeConverter(const h, m, s: word): string;
function dateConverter(const d, m: byte; const y: word): string;
procedure showPopUpWnd(const c, t: string; const history: boolean = false);

var
  timeSpeak_handle: tHandle;
  messageSendHandle: tHandle;
  //timeDate: tTimeDateLabel;
  ctrlTimer: tTimer;
  ctrlPress: boolean;
  //trayIcon: tTrayIcon;

  gl_select_index: smallInt = -1;
  gl_first_selected: smallInt = -1;

  //al_selected: boolean;
  al_select_index: smallInt = -1;
  al_first_selected: smallInt = -1;
  
  //tl_selected: boolean;
  tl_select_index: smallInt = -1;
  tl_first_selected: smallInt = -1;

  //sl_selected: boolean;
  sl_select_index: smallInt = -1;
  sl_first_selected: smallInt = -1;

  {le_Alarm: smallInt = -1;
  le_Timer: smallInt = -1;}

  a_haveToPlay, a_haveToRepaint,
  t_haveToPlay, t_haveToRepaint: boolean;

  nowRingingPage: smallInt;

  groups: array of group_rec;
  alarmIndexes: array of smallInt;
  
  alarms: array of alarms_rec;
  timers: array of timers_rec;
  timerProfiles: array of record rec: timers_rec; name: string; end;
  secMers: array of secMers_rec;

  le_alarm: record rec: alarms_rec; exists: boolean; end;
  le_timer: record rec: timers_rec; exists: boolean; end;

  isOk: boolean;
  //ringing: boolean = false;

  //ac_item_index: smallInt;

  //allowTimeSpeak: boolean = true;
  statusBarCaption: string = '';
const
   f_not_exist: string = '    ';
   t_not_right: string = '   !';

   //mSelectKey: word = 77;

implementation

uses
  windows, calendarEdit, SysUtils, popUp, graphics, forms;

procedure calendarRepaint;
begin
   calendarEdit_form.dayEdit.Repaint;
end;

function checkSymbols(const value: string): boolean;
var
c: word;
begin
   result := false;

   if value = '' then exit;
   
   for c := 0 to length(value) do
      if (value[c] <> ' ') then
      begin
         result := true;
         exit;
      end;
end;

function{   }timeConverter(const h, m, s: word): string;
var
second, minute, hour: string;
begin
   second := intToStr(s);
   minute := intToStr(m);
   hour := intToStr(h);

   if length(second) < 2 then
   begin
      if length(second) < 1 then second := '00'
      else second := '0' + second;
   end;
   if length(minute) < 2 then
   begin
      if length(minute) < 1 then minute := '00'
      else minute := '0' + minute;
   end;
   if length(hour) < 2 then
   begin
      if length(hour) < 1 then hour := '00'
      else hour := '0' + hour;
   end;
   result := hour+':'+minute+':'+second;
end;

function{   }dateConverter(const d, m: byte; const y: word): string;
var
day, month, year: string;
begin
   day := intToStr(d);
   month := intToStr(m);
   year := intToStr(y);

   if length(day) < 2 then day := '0' + day;
   if length(month) < 2 then month := '0' + month;
   result := day+'.'+month+'.'+year;
end;

procedure showPopUpWnd(const c, t: string; const history: boolean = false);
procedure setPos;
var
rec: tRect;
wnd: hwnd;
tbHeight: word;
begin
   wnd := FindWindow('Shell_TrayWnd', Nil);
   If wnd<>0 then
   begin
      Windows.GetClientRect(wnd, Rec);
      tbHeight := rec.Bottom;
   end else tbHeight := 0;

   case utils_form.s8_edit.ItemIndex of
   0:
   begin
      popup_form.left := screen.Width - popup_form.width;
      popup_form.top := screen.height - popup_form.height - tbHeight;
   end;
   1:
   begin
      popup_form.left := 0;
      popup_form.top := screen.height - popup_form.height - tbHeight;
   end;
   2:
   begin
      popup_form.left := screen.Width - popup_form.width;
      popup_form.top := 0;
   end;
   3:
   begin
      popup_form.left := 0;
      popup_form.top := 0;
   end;
   4:
   begin
      popup_form.left := screen.Width div 2 - popup_form.width div 2;
      popup_form.top := screen.height div 2 - popup_form.height div 2;
   end;
   5, 6:
   begin
      popup_form.left := utils_form.s9_edit.Value;
      popup_form.top := utils_form.s10_edit.Value;
   end;
   end;
end;
begin
   setPos();
   {if s8_edit.ItemIndex < 6 then
      popUp.popUpPos := tPopUpPos(s8_edit.ItemIndex)
   else
      popUp.popUpPos := tPopUpPos(5);

      popUp.hideAfter := s7_edit.Value * 1000;}
      //popUp.onTop := true;



   if history then
   begin
      popUp_form.close;
      popUp_form.textOut.Color := clBtnFace;

      popUp_form.blink_Timer.Enabled := false;
      popUp_form.autoHide_timer.Enabled := false;
   end
   else
   begin
      //popUp.autoHide := s6_btn.Checked;
      //popUp.Blink := s20_btn.Checked;
      if not utils_form.s20_btn.Checked then
      popUp_form.textOut.Color := clBtnFace;

      popUp_form.blink_Timer.Interval := utils_form.s21_edit.Value * 100;
      popUp_form.autoHide_timer.Interval := utils_form.s7_edit.Value * 1000;

      popUp_form.blink_Timer.Enabled := utils_form.s20_btn.Checked;
      popUp_form.autoHide_timer.Enabled := utils_form.s6_btn.Checked;
   end;

   if not utils_form.s30_btn.Checked then
   begin
      popUp_form.Width := 250;
      popUp_form.Height := 150;
   end;

   popUp_form.Caption := c;
   
   if IsWindowVisible(popUp_form.Handle) then
      popUp_form.textOut.Text := t+#13#10 + popUp_form.textOut.Text
   else
      popUp_form.textOut.Text := t;

   popUp_form.show;
end;

end.
