unit groupEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, pngextra, ExtCtrls, StdCtrls, ComCtrls, Menus;

type
  TgroupEdit_form = class(TForm)
    groupView: TListView;
    ctrl_panel1: TPanel;
    edit_button: TPNGButton;
    del_button: TPNGButton;
    del_all_button: TPNGButton;
    add_button: TPNGButton;
    visible_button: TSpeedButton;
    a_menu_button: TSpeedButton;
    groupMenu: TPopupMenu;
    _add: TMenuItem;
    _edit: TMenuItem;
    _del: TMenuItem;
    _delAll: TMenuItem;
    N5: TMenuItem;
    _visible: TMenuItem;
    _select: TMenuItem;
    _selectAll: TMenuItem;
    _selectVisible: TMenuItem;
    _selectInvisible: TMenuItem;
    _selectInvert: TMenuItem;
    select_button: TPNGButton;
    _show: TMenuItem;
    _showAll: TMenuItem;
    _showSelected: TMenuItem;
    _hide: TMenuItem;
    _hideAll: TMenuItem;
    _hideSelected: TMenuItem;
    _selectSelected: TMenuItem;
    procedure _hideSelectedClick(Sender: TObject);
    procedure _showSelectedClick(Sender: TObject);
    procedure _hideAllClick(Sender: TObject);
    procedure _showAllClick(Sender: TObject);
    procedure select_buttonClick(Sender: TObject);
    procedure _selectInvertClick(Sender: TObject);
    procedure _selectInvisibleClick(Sender: TObject);
    procedure _selectVisibleClick(Sender: TObject);
    procedure _selectAllClick(Sender: TObject);
    procedure a_menu_buttonClick(Sender: TObject);
    procedure _visibleClick(Sender: TObject);
    procedure groupViewCustomDrawItem(Sender: TCustomListView; Item: TListItem;
      State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure visible_buttonClick(Sender: TObject);
    procedure groupViewDblClick(Sender: TObject);
    procedure groupViewSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure del_buttonClick(Sender: TObject);
    procedure edit_buttonClick(Sender: TObject);
    procedure del_all_buttonClick(Sender: TObject);
    procedure add_buttonClick(Sender: TObject);
  private
    { Private declarations }
    count: smallInt;
  public
    { Public declarations }
  published
     procedure listCreate;

     procedure onlyDel(const index: smallInt; const delAlarms: boolean);
     procedure selectAfterDel(const index: smallInt; const delAlarms: boolean);

     function areAnySelected: smallInt;
     procedure listSelect(const index: smallInt; const selected: boolean);
     procedure setVisible(const index: smallInt; const value: boolean);
     procedure editItem(const index: smallInt);
     procedure edit(const index: smallInt);
     function getFirstSelected: smallInt;
     procedure selectSelected;
     procedure setAllVisible(const value: boolean);
     function isVisible: smallInt;
  end;

var
  groupEdit_form: TgroupEdit_form;

implementation

uses global_vars, ats, alarm_utils, utils;

{$R *.dfm}

{ TgroupEdit_form }

procedure{   }TgroupEdit_form.add_buttonClick(Sender: TObject);
var
note: string;
c: smallInt;
hv: smallInt;
begin
   repeat
      if not inputQuery(' ',
      '    ', note) then exit;
   until trim(note) <> '';

   setLength(groups, high(groups)+2);
   hv := high(groups);

   groups[hv].name := note;
   groups[hv].visible := true;
   groups[hv].alarmsCount := 0;

   if areAnySelected <= 1 then
   begin
      groups[hv].selected := true;
      for c := 0 to hv - 1 do
      groups[c].selected := false;
   end;

   gl_select_index := high(groups);
   listCreate;
end;

function{ -  }TgroupEdit_form.areAnySelected: smallInt;
var
c: smallInt;
begin
   result := 0;
   for c := 0 to groupView.Items.Count - 1 do
      if groupView.Items[c].selected then inc(result);
end;

procedure TgroupEdit_form.a_menu_buttonClick(Sender: TObject);
var
p: tPoint;
begin
   getCursorPos(p);
   groupMenu.Popup(p.x, p.y);
end;

procedure{    }TgroupEdit_form.del_all_buttonClick(Sender: TObject);
var
c: smallInt;
begin
   if messageDlg('     ?', mtConfirmation, mbYesNo, 0) <> mrYes then exit;
   if high(alarms) >= 0 then
   begin
      for c := 0 to high(alarms) do
         alarms[c].groupIndex := -1;
   end;
   setLength(groups, 0);
   gl_select_index := -1;
   listCreate;
   alarm.listCreate;
end;

procedure{   }TgroupEdit_form.del_buttonClick(Sender: TObject);
var
mr, c: smallInt;
haveToDel: array of smallInt;
begin
   {if gl_select_index = 0 then
   begin
      messageDlg(' !', mtWarning, [mbOk], 0);
      exit;
   end; }

   mr := messageDlg('      '+
   '   ?'+#13#10+' -     '+
   #13#10+' -  ,      ',
   mtConfirmation, mbYesNoCancel, 0);

   if not (mr in [mrYes, mrNo]) then exit;

   for c := 0 to high(groups) do
     if groups[c].selected then
     begin
        setLength(haveToDel, high(haveToDel)+2);
        haveToDel[high(haveToDel)] := c;
     end;

   for c := high(haveToDel) downto 0 do
      onlyDel(haveToDel[c], mr = mrYes);

   selectAfterDel(gl_first_selected, mr = mrYes);

   //alarm.listCreate;
end;

procedure{  }TgroupEdit_form.edit(const index: smallInt);
var
note: string;
begin
   gl_select_index := index;

   note := groups[index].name;

   if not inputQuery(' ',
   '    ', note) then exit;

   groups[index].name := note;
   editItem(index);
   alarm.listCreate;
   listSelect(index, index >= 0);
end;

procedure{   }TgroupEdit_form.editItem(const index: smallInt);
begin
    at_addEdit_form.groupSelect.Items[index] := groups[index].name;
    with groupView.Items[index] do
    begin
       caption := intToStr(index+1);
       SubItems.Clear;
       SubItems.Add(groups[index].name);
       if groups[index].visible then
          SubItems.Add('')
       else
          SubItems.Add(' ');

       subItems.Add(intToStr(groups[index].alarmsCount));
    end;
    with utils_form._moveIntoGroup[index] do
    begin
       caption := groups[index].name;
       onClick := alarm.moveToGroup;
       tag := index;
    end;
end;

procedure{  }TgroupEdit_form.edit_buttonClick(Sender: TObject);
begin
   if areAnySelected >= 0 then   
   edit(gl_select_index);
end;

function{     }TgroupEdit_form.getFirstSelected: smallInt;
var
c: smallInt;
begin
   result := -1;
   if high(groups) < 0 then exit;

   for c := 0 to high(groups) do
   begin
      if groups[c].selected then
      begin
         result := c;
         exit;
      end;
   end;
end;

procedure TgroupEdit_form.groupViewCustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
   if groups[item.Index].visible then
      groupView.Canvas.Brush.Color := utils_form.s23_edit.Color
   else
      groupView.Canvas.Brush.Color := utils_form.s24_edit.Color;

   if item.Selected then
      groupView.Canvas.Font.Style :=
      groupView.Canvas.Font.Style + [fsBold];
end;

procedure{     }TgroupEdit_form.groupViewDblClick(Sender: TObject);
begin
   if utils_form.s29_btn.Checked and (gl_select_index > -1) and
      (gl_select_index <= high(groups)) and
      (high(groups) >= 0) then
   begin
      if not groups[gl_select_index].visible then
      setVisible(gl_select_index, true);
      alarm.listCreate;
   end;

   select_buttonClick(nil);
   {//+++++++++++++++++++++++
   if areAnySelected = 0 then exit;

   for c := 0 to high(groups) do
     if c <> gl_select_index then
        setVisible(c, false);

   setVisible(gl_select_index, true);

   alarm.listCreate;}
end;

procedure{   }TgroupEdit_form.groupViewSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
   listSelect(item.Index, selected);
end;

function{  -     }TgroupEdit_form.isVisible: smallInt;
var
c: smallInt;
begin
   result := 0;
   if high(groups) < 0 then exit;
   for c := 0 to high(groups) do
      if groups[c].selected and groups[c].visible then inc(result);
end;

procedure{   }TgroupEdit_form.listCreate;
var
c: smallInt;
begin
   groupView.Clear;
   at_addEdit_form.groupSelect.Clear;
   utils_form._moveIntoGroup.Clear;

   if high(groups) < 0 then
   begin
      //at_addEdit_form.groupSelect.Clear;
      //utils_form._moveIntoGroup.Clear;
      del_all_button.Enabled := false;
      _delAll.Enabled := false;
      _select.Enabled := false;
      _show.Enabled := false;
      _hide.Enabled := false;

      utils_form._moveIntoGroup.Add(tMenuItem.Create(application));
      utils_form._moveIntoGroup.Items[0].caption := '( )';
      utils_form._moveIntoGroup.Items[0].OnClick := alarm.addGroup;

      exit;
   end;
   groupView.Items.BeginUpdate;
   for c := 0 to high(groups) do
   begin
      groupView.Items.Add;
      utils_form._moveIntoGroup.Add(tMenuItem.Create(application));
      at_addEdit_form.groupSelect.Items.Add('');
      editItem(c);
   end;
   c := high(groups);
   utils_form._moveIntoGroup.Add(tMenuItem.Create(application));
   utils_form._moveIntoGroup.Items[c+1].Caption := '-';

   utils_form._moveIntoGroup.Add(tMenuItem.Create(application));
   utils_form._moveIntoGroup.Items[c+2].caption := '( )';
   utils_form._moveIntoGroup.Items[c+2].Tag := -1;
   utils_form._moveIntoGroup.Items[c+2].OnClick := alarm.moveToGroup;

   utils_form._moveIntoGroup.Add(tMenuItem.Create(application));
   utils_form._moveIntoGroup.Items[c+3].caption := '( )';
   utils_form._moveIntoGroup.Items[c+3].OnClick := alarm.addGroup;


   groupView.Items.EndUpdate;

   del_all_button.Enabled := true;
   _delAll.Enabled := true;
   _select.Enabled := true;
   _show.Enabled := true;
   _hide.Enabled := true;

   for c := 0 to high(groups) do
     groupView.Items[c].Selected := groups[c].selected;
   calendarRepaint;
end;

procedure{   }TgroupEdit_form.listSelect(const index: smallInt; const selected: boolean);
var
anySelected, visibleSelected: boolean;
begin
   if selected then gl_select_index := index else gl_select_index := -1;

   if index >= 0 then
   begin
      groups[index].selected := selected;
      anySelected := areAnySelected > 0;
      visibleSelected := isVisible > 0;
   end
   else
   begin
      anySelected := false;
      visibleSelected := false;
   end;

   gl_first_selected := getFirstSelected;

   edit_button.Enabled := anySelected;
   del_button.Enabled := anySelected;
   visible_button.Enabled := anySelected;
   _visible.enabled := anySelected;
   _edit.enabled := anySelected;
   _del.enabled := anySelected;
   select_button.Enabled := visibleSelected;
   _selectSelected.Enabled := visibleSelected;

   if anySelected then
   begin
      visible_button.down:= groups[gl_first_selected].visible;
      _visible.Checked := groups[gl_first_selected].visible;
   end;
end;

procedure TgroupEdit_form.onlyDel(const index: smallInt; const delAlarms: boolean);
var
c: smallInt;
haveToDel: array of smallInt;
begin
   if high(alarms) >= 0 then
   begin
      if delAlarms then
      begin
         for c := 0 to high(alarms) do
         begin
            if alarms[c].groupIndex = index then
            begin
               setLength(haveToDel, high(haveToDel)+2);
               haveToDel[high(haveToDel)] := c;
            end;
            if alarms[c].groupIndex > index then
            alarms[c].groupIndex := alarms[c].groupIndex - 1;
         end;
         for c := high(haveToDel) downto 0 do
            alarm.onlyDel(haveToDel[c]);
      end
      else
      begin
         for c := 0 to high(alarms) do
         begin
            if alarms[c].groupIndex = index then
               alarms[c].groupIndex := -1;
            if alarms[c].groupIndex > index then
               alarms[c].groupIndex := alarms[c].groupIndex - 1;
         end;
      end;
   end;
   
   for c := index to high(groups) - 1 do
   groups[c] := groups[c + 1];
   setLength(groups, high(groups));
end;

procedure TgroupEdit_form._showAllClick(Sender: TObject);
begin
   setAllVisible(true);
   alarm.listCreate;
end;

procedure TgroupEdit_form._showSelectedClick(Sender: TObject);
var
c: smallInt;
begin
   if high(groups) < 0 then exit;
   for c := 0 to high(groups) do
     if groups[c].selected then setVisible(c, true);
   alarm.listCreate;
end;

procedure TgroupEdit_form._hideAllClick(Sender: TObject);
begin
   setAllVisible(false);
   alarm.listCreate;
end;

procedure TgroupEdit_form._hideSelectedClick(Sender: TObject);
var
c: smallInt;
begin
   if high(groups) < 0 then exit;
   for c := 0 to high(groups) do
     if groups[c].selected then setVisible(c, false);
   alarm.listCreate;
end;

procedure TgroupEdit_form._selectInvisibleClick(Sender: TObject);
var
c: smallInt;
//multiNotPress: Boolean;
begin
   if high(groups) < 0 then exit;

   //multiNotPress := getasynckeystate(mSelectKey) = 0;

   for c := 0 to high(groups) do
     if not groups[c].visible then
       groupView.Items[c].Selected := true
     else
       if not ctrlPress then groupView.Items[c].Selected := false;

   try
      groupView.SetFocus;
   except

   end;
end;

procedure TgroupEdit_form._selectInvertClick(Sender: TObject);
var
c: smallInt;
begin
   if high(groups) < 0 then exit;
   for c := 0 to high(groups) do
        groupView.Items[c].Selected := not groups[c].selected;
end;

procedure TgroupEdit_form._visibleClick(Sender: TObject);
var
c: smallInt;
begin
   if areAnySelected = 0 then exit;

   for c := 0 to high(groups) do
     if groups[c].selected then
     setVisible(c, _visible.Checked);

   alarm.listCreate;
end;

procedure TgroupEdit_form._selectAllClick(Sender: TObject);
var
c: smallInt;
begin
   if high(groups) < 0 then exit;
   for c := 0 to high(groups) do
     groupView.Items[c].Selected := true;
end;

procedure TgroupEdit_form._selectVisibleClick(Sender: TObject);
var
c: smallInt;
//multiNotPress: Boolean;
begin
   if high(groups) < 0 then exit;

   //multiNotPress := getasynckeystate(mSelectKey) = 0;

   for c := 0 to high(groups) do
     if groups[c].visible then
       groupView.Items[c].Selected := true
     else
       if not ctrlPress then groupView.Items[c].Selected := false;

   try
      groupView.SetFocus;
   except

   end;
end;

procedure TgroupEdit_form.selectAfterDel(const index: smallInt;
  const delAlarms: boolean);
var
c: smallInt;
haveToDel: array of smallInt;
begin
   if (high(alarms) >= 0) and delAlarms then
      alarm.selectAfterDel(-1);

   count := high(groups);
   if count >= 0 then
      if index > count then gl_select_index := count else gl_select_index := index
   else
      gl_select_index := -1;

   listCreate;

   listSelect(gl_select_index, gl_select_index >= 0);
   if gl_select_index >= 0 then
     groupView.Items[gl_select_index].Selected := true;

   alarm.listCreate;
end;

procedure{     }TgroupEdit_form.selectSelected;
var
c: smallInt;
//multiNotPress: boolean;
begin
   if alarm.listView.Items.Count = 0 then exit;
   //multiNotPress := getasynckeystate(mSelectKey) = 0;

   {for c := 0 to high(alarms) do
   if alarms[c].groupIndex = gl_select_index then
      alarm.listView.Items[c].Selected := true
   else
      if multiNotPress then alarm.listView.Items[c].Selected := false;}

   for c := 0 to alarm.listView.Items.Count - 1 do
     if groups[alarms[alarmIndexes[c]].groupIndex].selected then
        alarm.listView.Items[c].Selected := true
     else
        if not ctrlPress then alarm.listView.Items[c].Selected := false;

   try
      alarm.listView.SetFocus;
   except

   end;
end;

procedure TgroupEdit_form.select_buttonClick(Sender: TObject);
begin
   if areAnySelected = 0 then exit;
   selectSelected;
end;

procedure TgroupEdit_form.setAllVisible(const value: boolean);
var
counter: smallInt;
begin
   count := high(groups);
   if count < 0 then exit;
   counter := 0;
   while counter <= count do
   begin
      //if groups[alarms[counter].groupIndex].visible then
      groups[counter].visible := value;
      inc(counter);
   end;
   listCreate;
end;

procedure{  }TgroupEdit_form.setVisible(const index: smallInt; const value: boolean);
begin
   groups[index].visible := value;
   editItem(index);
   _visible.Checked := value;
   visible_button.Down := value;
end;

procedure TgroupEdit_form.visible_buttonClick(Sender: TObject);
var
c: smallInt;
begin
   if areAnySelected = 0 then exit;

   for c := 0 to high(groups) do
     if groups[c].selected then
     setVisible(c, visible_button.Down);

   alarm.listCreate;
end;

end.
