unit main;

interface

uses
  Classes, Forms, Menus, ActnPopup, messages, windows, SysUtils, mmSystem,
  ExtCtrls, TimeDateLabel, Buttons, AppEvnts, ActnList, XPStyleActnCtrls,
  ActnMan, StdCtrls, Controls, registry, pngextra, xpman, ImgList, MPlayer;

const appVersion = '4.0 GOLD';

type
  tTrayHelper = record
     name, param, way: string;
  end;
  Tmain_form = class(TForm)
    main_menu: TPopupMenu;
    actions: TActionManager;
    clock_panel: tPanel;
    _is12: TAction;
    _on_top: TAction;
    _exit: TAction;
    _about: TAction;
    _utils: TAction;
    _hide_show: TAction;
    N11: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    N15: TMenuItem;
    N122: TMenuItem;
    N17: TMenuItem;
    N18: TMenuItem;
    events: TApplicationEvents;
    date_panel: TPanel;
    date_out: TTimeDateLabel;
    time_out: TTimeDateLabel;
    utils_button: TPNGButton;
    about_button: TPNGButton;
    _showHistory: TAction;
    N4: TMenuItem;
    _settings: TAction;
    _addAlarm: TAction;
    _addTimer: TAction;
    _addSecMer: TAction;
    N23: TMenuItem;
    N24: TMenuItem;
    N25: TMenuItem;
    N26: TMenuItem;
    _fixed: TAction;
    TrayIcon: TTrayIcon;
    N29: TMenuItem;
    _sayTime: TAction;
    N30: TMenuItem;
    N31: TMenuItem;
    _showCalendar: TAction;
    N16: TMenuItem;
    N27: TMenuItem;
    minimize_button: TPNGButton;
    _autostart: TAction;
    N1: TMenuItem;
    _changeFonColor: TMenuItem;
    _changeFontColor: TMenuItem;
    Images: TImageList;
    tray_menu: TPopupMenu;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem14: TMenuItem;
    MenuItem15: TMenuItem;
    MenuItem19: TMenuItem;
    MenuItem20: TMenuItem;
    _dubTime: TMenuItem;
    _dubTimeNever: TMenuItem;
    _dubTimeEveryHour: TMenuItem;
    _dubTimeEveryHalfHour: TMenuItem;
    N3: TMenuItem;
    _dubTimeSay: TMenuItem;
    _dubTimeWav: TMenuItem;
    mediaPlayer: TMediaPlayer;
    procedure _dubTimeSelectMethod(Sender: TObject);
    procedure dubTimeStepSelect(Sender: TObject);
    procedure _changeFontColorClick(Sender: TObject);
    procedure _changeFonColorClick(Sender: TObject);
    procedure _autostartExecute(Sender: TObject);
    procedure _showCalendarExecute(Sender: TObject);
    procedure _sayTimeExecute(Sender: TObject);
    procedure _addSecMerExecute(Sender: TObject);
    procedure _addTimerExecute(Sender: TObject);
    procedure _addAlarmExecute(Sender: TObject);
    procedure _showHistoryExecute(Sender: TObject);
    procedure eventsMinimize(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure _fixedExecute(Sender: TObject);
    procedure TrayIconClick(Sender: TObject);
    procedure _on_topClick(Sender: TObject);
    procedure _exitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure about_buttonClick(Sender: TObject);
    procedure time_outDblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure utils_buttonClick(Sender: TObject);
    procedure time_outRefresh(Sender: TObject);
  private
    { Private declarations }
    procedure save_settings;
    procedure Load_settings;
    procedure quickLaunch(sender: tObject);
    function getQuickLaunch: boolean;
    procedure hideShowForm(const hide: boolean);
    procedure buildTrayHelper;
    procedure thInsertItem(const caption: string; const tag: integer);
    procedure wmQueryEndSession(var m: tWmQueryEndSession); message Wm_QueryEndSession;
    procedure sayTime_endPlaying(var m: tMessage); message wm_user + 1;

    procedure WMHotKey(var Msg: TWMHotKey); message WM_HOTKEY;

    function checkAutoStart: boolean;
    procedure setAutoStart(const value: boolean);
    procedure dubTime;
    procedure mediaPlayerOnNotify(sender: tObject);
  public
    { Public declarations }
    procedure drowFonBmp;
    procedure drowFontBmp;
  end;

var
  main_form: Tmain_form;
  path, timeHint, dateHint, wayToWavRes: string;
  wasVisible: boolean;
  allowTimeSpeak: boolean = true;

  timeSay_HK, formHide_HK: integer;

  days: array [1..7] of string = ('', '',
  '', '', '', '', '');
  
  months: array [1..12] of string = ('', '', '',
  '', '', '', '', '', '',
  '', '', '');

  utils_exists: boolean;

  utils_handle, timeSpeak_handle: tHandle;

  utils_creating: procedure (const h1, h2: tHandle; const p1, p2: pointer); stdCall;
  utils_free, utils_timeTest,
  utils_fixed, utils_showHistory, utils_formShow, utils_showCalendar,
  utils_addAlarm, utils_addTimer, utils_addSecMer: procedure; stdCall;
  utils_getInfo: function: pChar; stdCall;
  //utils_getMayTimeSpeakVar: function: boolean; stdCall;

  timeSay: procedure(const hour, minute: word; const handle: tHandle; const user: integer); stdCall;
  stopSpeaking: procedure; stdCall;

  trayHelper: array of tTrayHelper;

implementation

uses about, iniFiles, Dialogs, Graphics;

{$R *.dfm}


function allowPlaying(const playingStarted: boolean = false): boolean; stdCall;
begin
   if playingStarted then
   begin
      allowTimeSpeak := false;
      main_form._sayTime.Enabled := false;
      result := false;
   end
   else
      result := allowTimeSpeak;
end;

procedure{    }setRinging(const ring: boolean); stdCall;
begin
   if ring then
   begin
      main_form.trayIcon.Animate := true;
   end
   else
   begin
      main_form.trayIcon.Animate := false;
      main_form.trayIcon.IconIndex := 0;
   end;
end;

procedure{   }TrimWorkingSet;
var
MainHandle: THandle;
begin
   if Win32Platform = VER_PLATFORM_WIN32_NT then
   begin
      MainHandle := OpenProcess(PROCESS_ALL_ACCESS, false, GetCurrentProcessID);
      SetProcessWorkingSetSize(MainHandle, DWORD(-1), DWORD(-1));
      CloseHandle(MainHandle);
   end;
end;

procedure{   }Tmain_form.save_settings;
var
iniFile: tIniFile;
begin
   try
   if not directoryExists(path+'_work') then createDir(path+'_work');
   if not directoryExists(path+'_work\Sounds') then createDir(path+'_work\Sounds');

   iniFile := tIniFile.Create(path+'_work\settings.ini');

   iniFile.WriteInteger('main_form', 'left', Left);
   iniFile.WriteInteger('main_form', 'top', top);

   iniFile.WriteInteger('settings', 'fonColor', clock_panel.Color);
   iniFile.WriteInteger('settings', 'fontColor', time_out.Font.Color);

   iniFile.WriteInteger('main_form', 'formStyle', integer(formStyle));
   iniFile.WriteBool('main_form', 'state', IsWindowVisible(handle));

   iniFile.WriteBool('settings', 'is12', time_out.is12);
   
   iniFIle.WriteString('settings', 'wayToWavRes', wayToWavRes);

   iniFile.WriteBool('main_form', 'state', IsWindowVisible(handle));

   iniFile.WriteBool('application', 'hasBeenStarted', true);

   iniFile.WriteBool('settings', 'autoStart', _autoStart.Checked);
   //  
   iniFile.WriteBool('settings', 'dubTimeNever', _dubTimeNever.Checked);
   iniFile.WriteBool('settings', 'dubTimeEveryHour', _dubTimeEveryHour.Checked);
   iniFile.WriteBool('settings', 'dubTimeEveryHalfHour', _dubTimeEveryHalfHour.Checked);

   iniFile.WriteBool('settings', 'dubTimeSay', _dubTimeSay.Checked);
   iniFile.WriteBool('settings', 'dubTimeWav', _dubTimeWav.Checked);

   iniFile.WriteString('settings', 'wayToWavRes', wayToWavRes);
   // ---------------------
   iniFile.Free;
   except

   end;
end;

procedure{   }Tmain_form.sayTime_endPlaying(var m: tMessage);
begin
   _sayTime.Enabled := true;
   allowTimeSpeak := true;
end;

procedure Tmain_form.setAutoStart(const value: boolean);
var
regFile: tRegIniFile;
begin
   regFile := tRegIniFile.Create('software\microsoft\windows\currentversion');
   if value then
     regFile.writeString('run', 'Atomik Clocker', application.ExeName)
   else
   begin
      regFile.OpenKey('run', true);
      regFile.DeleteValue('Atomik Clocker');
   end;
   regFile.Free;
end;

procedure{   }Tmain_form.load_settings;
var
iniFile: tIniFile;
begin
   iniFile := tIniFile.Create(path+'_work\settings.ini');

   left := iniFile.readInteger('main_form', 'left', screen.width div 2 - 86);
   top := iniFile.readInteger('main_form', 'top', screen.height div 2 - 55);

   clock_panel.Color :=
      iniFIle.ReadInteger('settings', 'fonColor', clWindowText);
   date_panel.color := clock_panel.Color;

   time_out.font.Color :=
      iniFIle.ReadInteger('settings', 'fontColor', clWindow);
   date_out.font.color := time_out.font.Color;

   drowFonBmp; drowFontBmp;

   if iniFile.ReadInteger('main_form', 'formStyle',
      integer(fsStayOnTop)) = integer(fsNormal) then
   begin
      _on_top.Checked := false;
      formStyle := fsNormal;
   end
   else
   begin
      _on_top.Checked := true;
      formStyle := fsStayOnTop;
   end;

   wasVisible := iniFile.ReadBool('main_form', 'state', true);

   time_out.is12 := iniFile.ReadBool('settings', 'is12', false);
   //  
   wayToWavRes := iniFile.ReadString('settings', 'wayToWavRes', '');

   _dubTimeNever.Checked := iniFile.ReadBool('settings', 'dubTimeNever', true);
   _dubTimeEveryHour.Checked := iniFile.ReadBool('settings', 'dubTimeEveryHour', false);
   _dubTimeEveryHalfHour.Checked := iniFile.ReadBool('settings', 'dubTimeEveryHalfHour', false);

   _dubTimeSay.Checked := iniFile.ReadBool('settings', 'dubTimeSay', true);
   _dubTimeWav.Checked := iniFile.ReadBool('settings', 'dubTimeWav', false);

   if fileExists(wayToWavRes) then
      _dubTimeWav.Caption := wayToWavRes
   else
      _dubTimeSay.Checked := false;

   _dubTime.Checked := not _dubTimeNever.Checked;
   // ----------------------
   _autoStart.Checked := checkAutoStart;

   _is12.Checked := time_out.is12;

   iniFile.Free;
end;

procedure Tmain_form.mediaPlayerOnNotify(sender: tObject);
begin
  { if mediaPlayer.NotifyValue = nvSuccessful then
      mediaPlayer.Free;}
end;

procedure{   quick launch }Tmain_form.quickLaunch(sender: tObject);
var
way: string;
begin
   way := trayHelper[tMenuItem(sender).tag].way+' '+trayHelper[tMenuItem(sender).tag].param;
   winExeC(pChar(way), SW_SHOWNORMAL);
end;

procedure{   " " }Tmain_form.about_buttonClick(Sender: TObject);
begin
   about_form.show;
end;

procedure{   }Tmain_form.buildTrayHelper;
var
counter: shortInt;
begin
   thInsertItem('-', 0);
   for counter := 0 to high(trayHelper) do
   begin
      thInsertItem(trayHelper[counter].name, counter);
   end;
end;

function Tmain_form.checkAutoStart: boolean;
var
regFile: tRegIniFile;
begin
   regFile := tRegIniFile.Create('software\microsoft\windows\currentversion');

   result := regFile.ReadString('run', 'Atomik Clocker', '')
   = application.ExeName;

   regFile.Free;
end;

procedure Tmain_form.drowFonBmp;
var
bmp: tBitmap;
begin
   bmp := tBitmap.create;
   bmp.Canvas.Brush.Color := clock_panel.Color;
   bmp.Canvas.pen.Color := clock_panel.Color;

   bmp.Width := 16;
   bmp.Height := 16;

   bmp.Canvas.Rectangle(2, 2, 15, 15);

   _changeFonColor.Bitmap.Assign(bmp);
   bmp.Free;
end;

procedure Tmain_form.drowFontBmp;
var
bmp: tBitmap;
begin
   bmp := tBitmap.create;
   bmp.Canvas.Brush.Color := time_out.font.Color;
   bmp.Canvas.pen.Color := time_out.font.Color;

   bmp.Width := 16;
   bmp.Height := 16;

   bmp.Canvas.Rectangle(2, 2, 15, 15);

   _changeFontColor.Bitmap.Assign(bmp);
   bmp.Free;
end;

procedure Tmain_form.dubTime;
begin
   if _dubTimeSay.Checked then
      _sayTimeExecute(nil);

   if _dubTimeWav.Checked and fileExists(wayToWavRes) then
   begin
      try
         mediaPlayer.Stop;
         mediaPlayer.Close;
      except

      end;
      //mediaPlayer := tMediaPlayer.Create(application);
      try
      mediaPlayer.OnNotify := mediaPlayerOnNotify;
      mediaPlayer.FileName := wayToWavRes;
      mediaPlayer.Open;
      mediaPlayer.Play;
      except
         beep;  
      end;
      //sndPlaySound(pChar(wayToWavRes), SND_ASYNC);
   end;
end;

procedure{     }Tmain_form.dubTimeStepSelect(Sender: TObject);
begin
   _dubTime.Checked := tMenuItem(sender).Tag = 1;
   tMenuItem(sender).Checked := true;

   if sender = _dubTimeNever then exit;
   if (not _dubTimeSay.Checked) and ((not _dubTimeWav.Checked or 
      (not fileExists(wayToWavRes)))) then
         if @timeSay <> nil then _dubTimeSay.Checked := true
      else
         _dubTimeWav.OnClick(_dubTimeWav);     

end;

procedure{   }Tmain_form.eventsMinimize(Sender: TObject);
begin
   hideShowForm(true);
end;

procedure{   }Tmain_form.FormActivate(Sender: TObject);
begin
   time_out.onRefresh := time_outRefresh;
   //ShowWindow(Application.Handle, SW_HIDE);{ alwaysOnTop }
   if not wasVisible then hideShowForm(true);
end;

procedure{   }Tmain_form.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   main_form.save_settings;
   if not utils_exists then exit;

   utils_free;
   freeLibrary(utils_handle);
   freeLibrary(timeSpeak_handle);

   unRegisterHotKey(handle, timeSay_HK);
   unRegisterHotKey(handle, formHide_HK);
end;

procedure{   }Tmain_form.FormCreate(Sender: TObject);
begin
//   caption := 'Clocker v'+appVersion;

   utils_exists := false;

   path := extractFilePath(application.ExeName);

   //_changeFonColor.Bitmap := tBitmap.Create;
  // _changeFontColor.Bitmap := tBitmap.Create;

   load_settings;

   utils_handle := loadLibrary(pChar(path+'utilsdll.dll'));

   if utils_handle <> 0 then
   begin
      @utils_creating := getProcAddress(utils_handle, 'creating');
      @utils_free := getProcAddress(utils_handle, 'free');
      @utils_timeTest := getProcAddress(utils_handle, 'timeTest');
      @utils_formShow := getProcAddress(utils_handle, 'formShow');
      @utils_fixed := getProcAddress(utils_handle, 'fixed');
      @utils_getInfo := getProcAddress(utils_handle, 'getInfo');
      @utils_showHistory := getProcAddress(utils_handle, 'showHistory');

      @utils_addAlarm := getProcAddress(utils_handle, 'addAlarm');
      @utils_addTimer := getProcAddress(utils_handle, 'addTimer');
      @utils_addSecMer := getProcAddress(utils_handle, 'addSecMer');
      @utils_showCalendar := getProcAddress(utils_handle, 'showCalendar');
   end;

   timeSpeak_handle := loadLibrary(pChar(path+'timeSpeak.dll'));

   if timeSpeak_handle <> 0 then
   begin
      @timeSay := getProcAddress(timeSpeak_handle, 'sayTime');
      @stopSpeaking := getProcAddress(timeSpeak_handle, 'stopSpeaking');
   end;

   if @timeSay <> nil then
   begin
     _sayTime.Enabled := true;
     _dubTimeSay.Enabled := true;

     timeSay_HK := globalAddAtom('sayTime');
     RegisterHotKey(Handle, timeSay_HK, MOD_CONTROL, 192);
   end
   else
   begin
      _sayTime.Enabled := false;
      _dubTimeSay.Enabled := false;
      if _dubTimeSay.checked then
      begin
         _dubTime.Checked := false;
         _dubTimeNever.Checked := true;
      end;
   end;

   formHide_HK := globalAddAtom('formHide');
   RegisterHotKey(Handle, formHide_HK, MOD_ALT, 192);
   
   if @utils_creating <> nil then
   begin
      utils_creating(application.handle, handle, @setRinging, @allowPlaying);
      utils_exists := true;
      utils_button.Enabled := true;
      _addAlarm.Enabled := true;
      _addTimer.Enabled := true;
      _addSecMer.Enabled := true;
      _showCalendar.enabled := true;
   end;

   if getQuickLaunch then buildTrayHelper;
end;

function{     }Tmain_form.getQuickLaunch: boolean;
var
counter, count: shortInt;
iniFile: tIniFile;
begin
   result := false;
   if not fileExists(path+'_work\quickLaunch.ini') then exit;
   iniFile := tIniFIle.Create(path+'_work\quickLaunch.ini');
   count := iniFile.ReadInteger('quick launch', 'count', -1);
   if count = -1 then begin iniFIle.Free; exit; end;
   setLength(trayHelper, count+1);
   for counter := 0 to count do
   begin
      trayHelper[counter].name := iniFile.ReadString('quick launch',
         'name'+intToStr(counter), '(  !)');
      trayHelper[counter].way := iniFile.ReadString('quick launch',
         'way'+intToStr(counter), '');
      trayHelper[counter].param := iniFile.ReadString('quick launch',
         'param'+intToStr(counter), '');
   end;
   result := true;
   iniFile.Free;
end;

procedure Tmain_form.hideShowForm(const hide: boolean);
begin
   if hide then
   begin
      Application.ShowMainForm := false;
      ShowWindow(Application.Handle, SW_HIDE);
      ShowWindow(Application.MainForm.Handle, SW_HIDE);
   end
   else
   begin
      Application.ShowMainForm := true;
      ShowWindow(Application.Handle, SW_RESTORE);
      ShowWindow(Application.MainForm.Handle, SW_NORMAL);
      SetForegroundWindow(Application.MainForm.Handle);
      //ShowWindow(Application.Handle, SW_HIDE); { alwaysOnTop }
   end;
end;

procedure{    trayHelper }Tmain_form.thInsertItem(const caption: string; const tag: integer);
var
item: tMenuItem;
begin
   item := tMenuItem.Create(nil);
   item.Caption := caption;
   item.Tag := tag;
   item.OnClick := quickLaunch;
   tray_menu.Items.insert(0, item);
end;

procedure{ dbl    }Tmain_form.time_outDblClick(Sender: TObject);
begin
   time_out.is12 := not time_out.is12;
   _is12.Checked := time_out.is12;
end;

procedure{  }Tmain_form.time_outRefresh(Sender: TObject);
begin
   if time_out.is12 then
   begin
      timeHint := time_out.Caption+ ' (12-  ,';
      if time_out.isPm then
        timeHint := timeHint + ' PM);'
        else timeHint := timeHint + ' AM);';
   end else timeHint := time_out.Caption+' (24-  );';
   if utils_exists then
   time_out.Hint := timeHint + #13#10 + '---' + #13#10 + strPas(utils_getInfo)
   else time_out.Hint := timeHint;

   dateHint := days[dayofweek(date)]+', '+intToStr(date_out.day)+'- '+
   months[date_out.month]+' '+intToStr(date_out.year)+'- ;';
   date_out.Hint := dateHint;

   trayIcon.Hint := timeHint+#13#10+dateHint;

   if utils_exists then utils_timeTest;


   if _dubTimeEveryHour.Checked or _dubTimeEveryHalfHour.Checked then
   begin
      if (time_out.minutes = 0) and
      (time_out.seconds = 0) and _dubTimeEveryHour.Checked then dubTime;

      if (time_out.minutes in [0, 30]) and
      (time_out.seconds = 0) and _dubTimeEveryHalfHour.Checked then dubTime;
   end;

   TrimWorkingSet;

   {if ringing then
   begin
     trayIcon.Visible := not trayIcon.Visible;
   end;}
end;

procedure{    }Tmain_form.TrayIconClick(Sender: TObject);
begin
   if (not trayIcon.Animate) and allowTimeSpeak then
   begin
      if  IsWindowVisible(handle) then
         hideShowForm(true)
      else
         hideShowForm(false);
   end;
   _fixedExecute(nil);

   if (not allowTimeSpeak) and (@stopSpeaking <> nil) then
      stopSpeaking;
end;

procedure{     }Tmain_form.utils_buttonClick(Sender: TObject);
begin
   utils_formShow;
end;

procedure Tmain_form.WMHotKey(var Msg: TWMHotKey);
begin
   if (msg.HotKey = timeSay_HK) then
      _sayTime.OnExecute(nil);

   if (msg.HotKey = formHide_HK) then
      TrayIconClick(nil);
end;

procedure{     }Tmain_form.wmQueryEndSession(var m: tWmQueryEndSession);
begin
   main_form.save_settings;

   if not utils_exists then exit;

   utils_free;
   freeLibrary(utils_handle);
   m.result := 1;
end;

procedure{    }Tmain_form._addAlarmExecute(Sender: TObject);
begin
   if utils_exists then utils_addAlarm;
end;

procedure{    }Tmain_form._addTimerExecute(Sender: TObject);
begin
   if utils_exists then utils_addTimer;
end;

procedure Tmain_form._autostartExecute(Sender: TObject);
begin
   setAutoStart(_autoStart.Checked);
end;

procedure Tmain_form._changeFonColorClick(Sender: TObject);
var
cd: tColorDialog;
begin
   cd := tColorDialog.Create(self);
   cd.Color := clock_panel.Color;
   if not cd.Execute then exit;
   clock_panel.Color := cd.Color;
   date_panel.Color := cd.Color;
   drowFonBmp;
   cd.Free;
end;

procedure Tmain_form._changeFontColorClick(Sender: TObject);
var
cd: tColorDialog;
begin
   cd := tColorDialog.Create(self);
   cd.Color := time_out.font.Color;
   if not cd.Execute then exit;
   time_out.font.Color := cd.Color;
   date_out.font.Color := cd.Color;
   drowFontBmp;
   cd.Free;
end;

procedure{    }Tmain_form._dubTimeSelectMethod(Sender: TObject);
var
d: tOpenDialog;
begin
   tMenuItem(sender).Checked := true;

   if tMenuItem(sender).Tag = 0 then exit;

   d := tOpenDialog.Create(self);
   d.FileName := wayToWavRes;
   d.Filter := 'Wav (*.Wav)|*.wav| |*.*';

   if not d.Execute then
   begin
      if not FileExists(wayToWavRes) then
      _dubTimeWav.Checked := false;
      _dubTimeSay.Checked := @timeSay <> nil;
      
      if @timeSay = nil then
         _dubTimeNever.OnClick(_dubTimeNever);     
      
      d.Free;
      exit;
   end;

   wayToWavRes := d.FileName;
   _dubTimeWav.Caption := wayToWavRes;
   d.Free;
end;

procedure{  }Tmain_form._exitClick(Sender: TObject);
begin
   close;
end;

procedure{ fixed }Tmain_form._fixedExecute(Sender: TObject);
begin
   try
      mediaPlayer.Stop;
      mediaPlayer.Close;
   except

   end;

   if not utils_exists then exit;
   utils_fixed;
   _fixed.Enabled := false;
end;

procedure{    }Tmain_form._addSecMerExecute(Sender: TObject);
begin
   if utils_exists then utils_addSecMer;
end;

procedure{     }Tmain_form._on_topClick(Sender: TObject);
begin
   if formStyle = fsNormal then
   formStyle := fsStayOnTop
   else formStyle := fsNormal;
end;

procedure Tmain_form._showCalendarExecute(Sender: TObject);
begin
   if utils_exists then utils_showCalendar;   
end;

procedure{   }Tmain_form._showHistoryExecute(Sender: TObject);
begin
   utils_showHistory;
end;

procedure{   }Tmain_form._sayTimeExecute(Sender: TObject);
begin
   if (not allowTimeSpeak) or (@timeSay = nil) then exit;
   timeSay(time_out.hours, time_out.minutes, handle, wm_user + 1);
   _sayTime.Enabled := false;
   allowTimeSpeak := false;
end;

end.
