unit popUp;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, pngextra;

type
  TpopUp_form = class(TForm)
    textOut: TMemo;
    autoHide_timer: TTimer;
    blink_Timer: TTimer;
    ctrl_panel: TPanel;
    close_btn: TPNGButton;
    utils_btn: TPNGButton;
    procedure textOutMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure textOutMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure utils_btnClick(Sender: TObject);
    procedure textOutMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure autoHide_timerTimer(Sender: TObject);
    procedure blink(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure textOutDblClick(Sender: TObject);
  private
    { Private declarations }
    leftBtnDown: boolean;
  public
    { Public declarations }
    procedure wmActivate(var message: tWMActivate); message WM_ACTIVATE;
  end;

var
  popUp_form: TpopUp_form;

implementation

uses utils, groupEdit, soundPlay, global_vars;

{$R *.dfm}

procedure TpopUp_form.autoHide_timerTimer(Sender: TObject);
begin
   close;
end;

procedure TpopUp_form.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   with utils_form do
   begin
      if s8_edit.ItemIndex = 6 then
      begin
         s9_edit.Value := popUp_form.Left;
         s10_edit.Value := popUp_form.Top;
      end;
   end;
   ctrl_panel.Visible := false;
end;

procedure TpopUp_form.FormShow(Sender: TObject);
begin
   leftBtnDown := false;
end;

procedure TpopUp_form.textOutDblClick(Sender: TObject);
begin
   if (not AllowPlaying) and not (@stopSpeaking = nil) then stopSpeaking;

   _player.stop;
   setRinging(false);
   close;
end;

procedure TpopUp_form.textOutMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if button = mbLeft then
      leftBtnDown := true;   
end;

procedure TpopUp_form.textOutMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   utils_btn.Enabled := nowRingingPage <> -1;
   ctrl_panel.Visible := (x <= 25) and (y <= 15) and not leftBtnDown;
end;

procedure TpopUp_form.textOutMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if button = mbLeft then
   begin
      leftBtnDown := false;
      if (ssCtrl in Shift) and (nowRingingPage <> -1) then
      begin
         utils_form.pages.ActivePageIndex := nowRingingPage;
         //         showForm
         if not IsWindowVisible(utils_form.handle) then
         utils_form.Show;
      
         setForegroundWindow(utils_form.handle);
         //----------------------------------------------------------------
         textOutDblClick(nil);
      end;
   end;
end;

procedure TpopUp_form.utils_btnClick(Sender: TObject);
begin
   textOutMouseUp(nil, mbLeft, [ssCtrl], 0, 0);
end;

procedure TpopUp_form.wmActivate(var message: tWMActivate);
begin
   if message.Minimized then close;   
end;

procedure TpopUp_form.blink(Sender: TObject);
begin
   if textOut.Color = clBtnFace then
      textOut.Color := utils_form.s22_edit.Color
   else
      textOut.Color := clBtnFace;
end;

end.
