unit save_load_settings;

interface

uses iniFiles, ats, utils, Forms, graphics;

procedure save_settings;
procedure load_settings;

implementation

uses alarm_utils, global_vars, SysUtils, Dialogs, timer_utils, secMer_utils,
  calendarEdit, groupEdit, popUp;

procedure save_settings;
var
iniFile: tIniFile;
counter: smallInt;
begin
   try
   if not utils_form.s31_btn.Checked then
   begin
      alarm.saveList;
      timer.saveList;
      secMer.saveList;
   end;

   iniFile := tIniFile.Create(extractFilePath(application.ExeName)+'_work\settings.ini');

   if integer(utils_form.windowState) = integer(wsNormal) then
   begin
      iniFile.WriteInteger('utils_form', 'left', utils_form.Left);
      iniFile.WriteInteger('utils_form', 'top', utils_form.top);
      iniFile.WriteInteger('utils_form', 'height', utils_form.height);
      iniFile.WriteInteger('utils_form', 'width', utils_form.width);
   end;
   iniFile.WriteInteger('utils_form', 'windowState', integer(utils_form.windowState));
   iniFile.WriteInteger('utils_form', 'page', utils_form.pages.ActivePageIndex);

   iniFile.WriteBool('calendarEdit_form', 'showMore', calendarEdit_form.more_btn.Down);
   for counter := 0 to 5 do
     iniFIle.WriteBool('calendarEdit_form', 'mode'+intToStr(counter), calendarEdit_form.calendar_mode.Checked[counter]);
   //************
   iniFile.WriteBool('settings', 'remember', utils_form.s1_btn.checked);
   iniFile.WriteBool('settings', 'confirm', utils_form.s2_btn.checked);
   //
   iniFile.WriteBool('settings', 'showInfo', utils_form.s3_btn.checked);
   iniFile.WriteBool('settings', 'edit', utils_form.s4_btn.checked);
   iniFile.WriteBool('settings', 'delete', utils_form.s5_btn.checked);
   //
   iniFile.WriteBool('settings', 'hidePopUp', utils_form.s6_btn.checked);
   iniFile.WriteInteger('settings', 'hidePopUpAfter', utils_form.s7_edit.value);
   //
   iniFile.WriteInteger('settings', 'popIn', utils_form.s8_edit.ItemIndex);
   iniFile.WriteInteger('settings', 'popUpX', utils_form.s9_edit.value);
   iniFile.WriteInteger('settings', 'popUpY', utils_form.s10_edit.value);
   //
   iniFile.WriteBool('settings', 'loadAlarms', utils_form.s11_btn.checked);
   iniFile.WriteInteger('settings', 'alarmsLoadMode', utils_form.s12_edit.itemIndex);
   iniFile.WriteInteger('settings', 'alarmsInvertStatus', utils_form.s13_edit.itemIndex);

   iniFile.WriteBool('settings', 'loadTimers', utils_form.s14_btn.checked);
   iniFile.WriteInteger('settings', 'timersLoadMode', utils_form.s15_edit.itemIndex);
   iniFile.WriteInteger('settings', 'timersInvertStatus', utils_form.s16_edit.itemIndex);

   iniFile.WriteBool('settings', 'loadSecMers', utils_form.s17_btn.checked);
   iniFile.WriteInteger('settings', 'secMersLoadMode', utils_form.s18_edit.itemIndex);
   iniFile.WriteInteger('settings', 'secMersInvertStatus', utils_form.s19_edit.itemIndex);
   //
   iniFIle.WriteBool('settings', 'popUpBlink', utils_form.s20_btn.Checked);
   iniFIle.WriteInteger('settings', 'popUpBlinkInterval', utils_form.s21_edit.value);
   iniFIle.WriteInteger('settings', 'popUpBlinkColor', utils_form.s22_edit.Color);
   //
   iniFIle.WriteInteger('settings', 'activeLight', utils_form.s23_edit.Color);
   iniFIle.WriteInteger('settings', 'inactiveLight', utils_form.s24_edit.Color);
   iniFIle.WriteInteger('settings', 'alarmToday', utils_form.s25_edit.Color);
   iniFIle.WriteInteger('settings', 'alarmTimeOut', utils_form.s26_edit.Color);
   //
   iniFIle.WriteBool('settings', 'resetOnesInDay', utils_form.s27_btn.Checked);
   iniFIle.WriteBool('settings', 'delOnlyVisible', utils_form.s28_btn.Checked);
   iniFIle.WriteBool('settings', 'setVisibleIfItNot', utils_form.s29_btn.Checked);
   iniFIle.WriteBool('settings', 'rememderPopUpSize', utils_form.s30_btn.Checked);
   iniFIle.WriteBool('settings', 'prohibitSaving', utils_form.s31_btn.Checked);
   iniFIle.WriteBool('settings', 'loadAlarmsWithoutOld', utils_form.s32_btn.Checked);
   //
   iniFIle.writeInteger('settings', 'popUpWidth', popUp_form.Width);
   iniFIle.writeInteger('settings', 'popUpHeight', popUp_form.Height);
   //************
   iniFile.WriteInteger('ats_addEdit_form', 'left', at_addEdit_form.Left);
   iniFile.WriteInteger('ats_addEdit_form', 'top', at_addEdit_form.top);
   //

   //iniFile.WriteInteger('calendarEdit_form', 'left', calendarEdit_form.Left);
   //iniFile.WriteInteger('calendarEdit_form', 'top', calendarEdit_form.top);

   //iniFile.WriteInteger('groupEdit_form', 'left', groupEdit_form.Left);
   //iniFile.WriteInteger('groupEdit_form', 'top', groupEdit_form.top);

   iniFile.WriteInteger('groupEdit_form', 'width', groupEdit_form.width);
   iniFile.WriteInteger('groupEdit_form', 'height', groupEdit_form.height);

   for counter := 0 to 6 do
   iniFile.WriteInteger('alarm_colunms', intToStr(counter),
   alarm.listView.Column[counter].Width);

   for counter := 0 to 3 do
   iniFile.WriteInteger('group_colunms', intToStr(counter),
   groupEdit_form.groupView.Column[counter].Width);
   
   for counter := 0 to 6 do
   iniFile.WriteInteger('timer_colunms', intToStr(counter),
   timer.listView.Column[counter].Width);

   for counter := 0 to 4 do
   iniFile.WriteInteger('secMer_colunms', intToStr(counter),
   secMer.listView.Column[counter].Width);

   iniFile.Free;
   except

   end;
end;

procedure load_settings;
var
iniFile: tIniFile;
counter: smallInt;
begin
   iniFile := tIniFile.Create(extractFilePath(application.ExeName)+'_work\settings.ini');
   utils_form.Left := iniFile.ReadInteger('utils_form', 'left', 200);
   utils_form.top := iniFile.ReadInteger('utils_form', 'top', 200);
   utils_form.Width := iniFile.ReadInteger('utils_form', 'width', 408);
   utils_form.Height := iniFile.ReadInteger('utils_form', 'height', 427);
   if iniFile.readInteger('utils_form', 'windowState', integer(wsNormal)) = integer(wsMaximized) then
   utils_form.WindowState := wsMaximized else utils_form.WindowState := wsNormal;
   utils_form.pages.ActivePageIndex := iniFile.ReadInteger('utils_form', 'page', 0);

   calendarEdit_form.more_btn.Down := iniFile.ReadBool('calendarEdit_form', 'showMore', false);
   for counter := 0 to 5 do
     calendarEdit_form.calendar_mode.Checked[counter] := iniFIle.ReadBool('calendarEdit_form', 'mode'+intToStr(counter), true);
   //************
   utils_form.s1_btn.checked := iniFile.ReadBool('settings', 'remember', false);
   utils_form.s2_btn.checked := iniFile.ReadBool('settings', 'confirm', true);
   utils_form.s3_btn.checked := iniFile.ReadBool('settings', 'showInfo', true);
   utils_form.s4_btn.checked := iniFile.ReadBool('settings', 'edit', false);
   utils_form.s5_btn.checked := iniFile.ReadBool('settings', 'delete', false);
   //
   utils_form.s6_btn.Checked := iniFile.ReadBool('settings', 'hidePopUp', true);
   utils_form.s7_edit.Value := iniFile.ReadInteger('settings', 'hidePopUpAfter', 120);
   //
   utils_form.s8_edit.itemIndex := iniFile.ReadInteger('settings', 'popIn', 0);
   utils_form.s9_edit.Value := iniFile.ReadInteger('settings', 'popUpX', 0);
   utils_form.s10_edit.Value := iniFile.ReadInteger('settings', 'popUpY', 0);
   popUp_form.Left := utils_form.s9_edit.Value;
   popUp_form.Top := utils_form.s10_edit.Value;
   //
   utils_form.s11_btn.checked := iniFile.Readbool('settings', 'loadAlarms', true);
   utils_form.s12_edit.itemIndex := iniFile.ReadInteger('settings', 'alarmsLoadMode', 0);
   utils_form.s13_edit.itemIndex := iniFile.ReadInteger('settings', 'alarmsInvertStatus', 0);

   utils_form.s14_btn.checked := iniFile.Readbool('settings', 'loadTimers', true);
   utils_form.s15_edit.itemIndex := iniFile.ReadInteger('settings', 'timersLoadMode', 0);
   utils_form.s16_edit.itemIndex := iniFile.ReadInteger('settings', 'timersInvertStatus', 0);

   utils_form.s17_btn.checked := iniFile.Readbool('settings', 'loadSecMers', true);
   utils_form.s18_edit.itemIndex := iniFile.ReadInteger('settings', 'secMersLoadMode', 0);
   utils_form.s19_edit.itemIndex := iniFile.ReadInteger('settings', 'secMersInvertStatus', 0);
   //
   utils_form.s20_btn.Checked := iniFIle.ReadBool('settings', 'popUpBlink', true);
   utils_form.s21_edit.value := iniFIle.ReadInteger('settings', 'popUpBlinkInterval', 5);
   utils_form.s22_edit.color := iniFIle.ReadInteger('settings', 'popUpBlinkColor', $00ECECFF);
   //
   utils_form.s23_edit.color := iniFIle.ReadInteger('settings', 'activeLight', $00ECFFED);
   utils_form.s24_edit.color := iniFIle.ReadInteger('settings', 'inactiveLight', $00ECECFF);
   utils_form.s25_edit.color := iniFIle.ReadInteger('settings', 'alarmToday', clHotLight);
   utils_form.s26_edit.color := iniFIle.ReadInteger('settings', 'alarmTimeOut', clInactiveCaption);
   //
   utils_form.s27_btn.Checked := iniFIle.ReadBool('settings', 'resetOnesInDay', false);
   utils_form.s28_btn.Checked := iniFIle.ReadBool('settings', 'delOnlyVisible', true);
   utils_form.s29_btn.Checked := iniFIle.ReadBool('settings', 'setVisibleIfItNot', false);
   utils_form.s30_btn.Checked := iniFIle.ReadBool('settings', 'rememderPopUpSize', true);
   utils_form.s31_btn.Checked := iniFIle.ReadBool('settings', 'prohibitSaving', false);
   utils_form.s32_btn.Checked := iniFIle.ReadBool('settings', 'loadAlarmsWithoutOld', false);
   //
   popUp_form.Width := iniFIle.ReadInteger('settings', 'popUpWidth', 250);
   popUp_form.Height := iniFIle.ReadInteger('settings', 'popUpHeight', 150);
   //
   utils_form.s8_edit.OnChange(nil);
   utils_form.s6_btn.OnClick(nil);
   utils_form.s20_btn.OnClick(nil);
   //
   utils_form.s11_btn.OnClick(nil);
   utils_form.s14_btn.OnClick(nil);
   utils_form.s17_btn.OnClick(nil);
   //
   calendarEdit_form.more_btnClick(nil);
   //************

   at_addEdit_form.Left := iniFile.ReadInteger('ats_addEdit_form', 'left', 200);
   at_addEdit_form.top := iniFile.ReadInteger('ats_addEdit_form', 'top', 200);

   //calendarEdit_form.Left := iniFile.ReadInteger('calendarEdit_form', 'left', 200);
   //calendarEdit_form.top := iniFile.ReadInteger('calendarEdit_form', 'top', 200);

   //groupEdit_form.Left := iniFile.ReadInteger('groupEdit_form', 'left', 200);
   //groupEdit_form.top := iniFile.ReadInteger('groupEdit_form', 'top', 200);

   groupEdit_form.width := iniFile.ReadInteger('groupEdit_form', 'width', 134);
   groupEdit_form.height := iniFile.ReadInteger('groupEdit_form', 'height', 223);

   for counter := 0 to 6 do
   alarm.listView.Column[counter].Width :=
   iniFile.ReadInteger('alarm_colunms', intToStr(counter), 60);

   for counter := 0 to 3 do
   groupEdit_form.groupView.Column[counter].Width :=
   iniFile.ReadInteger('group_colunms', intToStr(counter), 60);

   for counter := 0 to 6 do
   timer.listView.Column[counter].Width :=
   iniFile.ReadInteger('timer_colunms', intToStr(counter), 60);

   for counter := 0 to 4 do
   secMer.listView.Column[counter].Width :=
   iniFile.ReadInteger('secMer_colunms', intToStr(counter), 60);
   {----------------------------------------------}
   alarm.loadList;
   timer.loadList;
   secMer.loadList;

   alarm.listCreate;
   timer.listCreate;
   secMer.listCreate;
   at_addedit_form.buildTimerProfeilesList;
   {----------------------------------------------}
   iniFile.Free;
end;

end.
