library utilsDll;

uses
  SysUtils,
  dialogs,
  windows,
  forms,
  ExtCtrls,
  graphics,
  Classes,
  alarm_utils in 'alarm_utils.pas',
  global_vars in 'global_vars.pas',
  save_load_settings in 'save_load_settings.pas',
  secMer_utils in 'secMer_utils.pas',
  timer_utils in 'timer_utils.pas',
  utils in 'utils form\utils.pas' {utils_form},
  soundPlay in 'soundPlay.pas',
  ats in 'ats addedit form\ats.pas' {at_addedit_form},
  calendarEdit in 'calendarEdit form\calendarEdit.pas' {calendarEdit_form},
  groupEdit in 'groupEdit form\groupEdit.pas' {groupEdit_form},
  popUp in 'popUp form\popUp.pas' {popUp_form};

{$R *.res}
{$R sources\sources.res}


procedure creating(const h1, h2: tHandle; const p1, p2: pointer); stdCall;
begin
   application.Handle := h1;
   messageSendHandle := h2;

   utils_form := tUtils_form.Create(application);
   at_addedit_form := Tat_addedit_form.Create(application);
   calendarEdit_form := TcalendarEdit_form.create(application);
   groupEdit_form := tGroupEdit_form.Create(application);
   popUp_form := tPopUp_form.Create(application);

   {}//windows.SetParent(calendarEdit_form.Handle, utils_form.alarm_page.Handle);

   alarm := tAlarmUtil.create;
   timer := tTimerUtil.create;
   secMer := tSecMerUtil.create;
   //_player := tPlayer.create;
   _player := tPlayer.create(utils_form.Player);

   alarm.listView := utils_form.alarm_List;
   timer.listView := utils_form.timer_list;
   secMer.listView := utils_form.secMer_list;
   //_player.player := utils_form.Player;
   //_player.player.OnNotify := _player.mPlayerNotify;

   {timeDate := tTimeDateLabel.Create(application);
   timeDate := tTimeDateLabel(td_pointer^);}

   timeSpeak_handle := loadLibrary(pChar(extractFilePath(application.ExeName)
      +'timeSpeak.dll'));

   @sayTime := getProcAddress(timeSpeak_handle, 'sayTime');
   @stopSpeaking := getProcAddress(timeSpeak_handle, 'stopSpeaking');
   at_addedit_form.say_time_button.Enabled := @sayTime <> nil;
   
   //@sayTime := p1;
   //at_addedit_form.say_time_button.Enabled := p1 <> nil;
   @AllowPlaying := p2;

   @setRinging := p1;

   load_settings;

   ctrlTimer := tTimer.create(application);
   ctrlTimer.interval := 50;
   ctrlTimer.onTimer := alarm.ctrlTimerOnTimer;
end;

procedure formShow; stdCall;
begin
   if IsWindowVisible(at_addedit_form.handle) then
   begin
      messageDlg('!   /!'+#13#10+
         '       !', mtWarning, [mbOk], 0);
      exit;
   end;

   if not IsWindowVisible(utils_form.handle) then
      utils_form.Show;
      
   setForegroundWindow(utils_form.handle);
end;

function getInfo: pChar; stdCall;
begin
   result := pChar(' ...'+#13#10+
   ': '+intToStr(high(alarms)+1)+';'+#13#10+
   ': '+intToStr(high(Timers)+1)+';'+#13#10+
   ': '+intToStr(high(secMers)+1)+';');
end;

procedure timeTest; stdCall;
begin
   alarm.timeTest;

   timer.timeMove;
   secMer.timeMove;

   {if ringing then
   begin
      trayIcon.Icon.LoadFromResourceName(hInstance, 'redClock');
      sleep(500);
      trayIcon.Icon.LoadFromResourceName(hInstance, 'mainIcon');
   end;}
end;

procedure showHistory; stdCall;
begin
   nowRingingPage := -1;
   //showHintMessage(pChar(' '), pChar(noteHistory), true);
   if noteHistory = '' then
   showPopUpWnd(' ', '(  )', true)
   else
   showPopUpWnd(' ', noteHistory, true);
end;

procedure free; stdCall;
begin
   save_settings;
   
   at_addedit_form.Free;
   utils_form.Free;
end;

procedure addAlarm; stdCall;
begin
   alarm.add;
end;

procedure addTimer; stdCall;
begin
   timer.add;
end;

procedure addSecMer; stdCall;
begin
   try
      secMer.add;
   except

   end;
end;

procedure fixed; stdCall;
begin
   popUp_form.textOut.OnDblClick(nil);
end;

procedure showCalendar; stdCall;
begin
   if IsWindowVisible(at_addedit_form.handle) then
   begin
      messageDlg('!   /!'+#13#10+
         '       !', mtWarning, [mbOk], 0);
      exit;
   end;

   utils_form.pages.ActivePageIndex := 0;
   if IsWindowVisible(utils_form.handle) then
   begin
      if getForegroundWindow = utils_form.handle then
         setForegroundWindow(utils_form.handle)
      else
         utils_form.Show;
   end
   else
      utils_form.Show;
   utils_form.showCalendar_buttonClick(nil);
end;

exports creating, formShow, addAlarm, addTimer, addSecMer,
timeTest, getInfo, showHistory, free, fixed, showCalendar;

begin
end.
