unit atomikCalendar;

interface

uses
  SysUtils, Classes, Controls, Grids, StdCtrls, calendar, Windows, Graphics;

type
  tAtomikCalendar = class(TCalendar)
  private
    { Private declarations }
    fDate: tDateTime;
    fBeforCellDrow, fAfterCellDrow: TDrawCellEvent;
    //fCanvas: tCanvas;
  protected
    { Protected declarations }
  public
    { Public declarations }
  published
    { Published declarations }
    constructor create(aOwner: tComponent); override;
    destructor free;

    procedure DrawCell(ACol, ARow: Longint; ARect: TRect; AState: TGridDrawState); override;
    property BeforCellDrow: TDrawCellEvent read fBeforCellDrow write fBeforCellDrow;
    property AfterCellDrow: TDrawCellEvent read fAfterCellDrow write fAfterCellDrow;
    property canvas;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('atomAltera', [tAtomikCalendar]);
end;

{ tAtomikCalendar }

constructor tAtomikCalendar.create(aOwner: tComponent);
begin
   inherited create(aOwner);
end;

procedure tAtomikCalendar.DrawCell(ACol, ARow: Integer; ARect: TRect;
  AState: TGridDrawState);
begin
   if assigned(fBeforCellDrow) then fBeforCellDrow(self, ACol, ARow, ARect, AState);
   inherited DrawCell(ACol, ARow, ARect, AState);
   if assigned(fAfterCellDrow) then fAfterCellDrow(self, ACol, ARow, ARect, AState);
end;


destructor tAtomikCalendar.free;
begin

end;

end.
